/***************************************************************************
 *            menage_db-fun.c
 *
 *  Mon Oct 24 17:56:26 2005
 *  Copyright  2005  Tomek Jankowski
 *  Email	tomcio-j@o2.pl
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <glade/glade.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gprintf.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>

#include "menage_db-fun.h"
#include "database-fun.h"
#include "interface-fun.h"

#define	SHORT_STRING	128

/*==================================================================================
 *	Globalnme wartosci zmiennej 'menage_db_mode' uzywanej jako argument w tym pliku	
 *==================================================================================
 *	'menage_db_mode':
 *	- 0 - "Autorzy"
 *	- 1 - "Gatunki"
 *	- 2 - "Wydwanictwa"
 *	- 3 - "Tlumacze"
 *	- 4 - "Języki"
 */
 
/*
 *	Funkcja ustawia wszytskie elementy okna 'menage_db_win' tak, zeby byly 
 *	zgodne z aktualnie edytowana tabela bazy danych
 */

void	set_menage_db_win_data_type	(GtkWidget	*widget, gint	mode)	{
	GladeXML			*xml;
	GtkTreeViewColumn	*column;
	GtkWidget			*list;
	GtkWidget			*authors_but;
	GtkWidget			*generes_but;
	GtkWidget			*pub_houses_but;
	GtkWidget			*translators_but;
	GtkWidget			*languages_but;
	GtkWidget			*label;
	GtkWidget			*entry;
	gchar				*markup;
	
	xml = glade_get_widget_tree (widget);
	/*	Ustawiamy wartosc globalnej zmiennej zgodnie z wartoscia wskazana przez
	 *	argument 'mode'
	 */
	menage_db_mode = mode;
	
	/*	Ustawiamy etykiete przyciskow w ramce "Menu". Jezeli przycisk jest aktywny
	 *	to pogrubiamy i podgreslamy tekst w etykiecie, inaczej zmienamy go na 
	 *	zwykly tekst	*/
	
	authors_but = glade_xml_get_widget (xml, "authors_but");
	generes_but = glade_xml_get_widget (xml, "generes_but");
	pub_houses_but = glade_xml_get_widget (xml, "pub_houses_but");
	translators_but = glade_xml_get_widget (xml, "translators_but");
	languages_but = glade_xml_get_widget (xml, "languages_but");
	
	switch (menage_db_mode)	{
		case 0:
			markup = g_markup_printf_escaped (_("<u><b>Authors</b></u>"));
			gtk_label_set_markup (GTK_LABEL (GTK_BIN (authors_but)->child), markup);
			gtk_label_set_text (GTK_LABEL (GTK_BIN (generes_but)->child), _("Generes"));
			gtk_label_set_text (GTK_LABEL (GTK_BIN (pub_houses_but)->child), _("Publish houses"));
			gtk_label_set_text (GTK_LABEL (GTK_BIN (translators_but)->child), _("Transtalors"));
			gtk_label_set_text (GTK_LABEL (GTK_BIN (languages_but)->child), _("Languages"));
			break;
		case 1:
			gtk_label_set_text (GTK_LABEL (GTK_BIN (authors_but)->child), _("Authors"));
			markup = g_markup_printf_escaped (_("<u><b>Generes</b></u>"));
			gtk_label_set_markup (GTK_LABEL (GTK_BIN (generes_but)->child), markup);
			gtk_label_set_text (GTK_LABEL (GTK_BIN (pub_houses_but)->child), _("Publish houses"));
			gtk_label_set_text (GTK_LABEL (GTK_BIN (translators_but)->child), _("Transtalors"));
			gtk_label_set_text (GTK_LABEL (GTK_BIN (languages_but)->child), _("Languages"));
			break;
		case 2:
			gtk_label_set_text (GTK_LABEL (GTK_BIN (authors_but)->child), _("Authors"));
			gtk_label_set_text (GTK_LABEL (GTK_BIN (generes_but)->child), _("Generes"));
			markup = g_markup_printf_escaped (_("<u><b>Publish houses</b></u>"));
			gtk_label_set_markup (GTK_LABEL (GTK_BIN (pub_houses_but)->child), markup);
			gtk_label_set_text (GTK_LABEL (GTK_BIN (translators_but)->child), _("Transtalors"));
			gtk_label_set_text (GTK_LABEL (GTK_BIN (languages_but)->child), _("Languages"));
			break;
		case 3:
			gtk_label_set_text (GTK_LABEL (GTK_BIN (authors_but)->child), _("Authors"));
			gtk_label_set_text (GTK_LABEL (GTK_BIN (generes_but)->child), _("Generes"));
			gtk_label_set_text (GTK_LABEL (GTK_BIN (pub_houses_but)->child), _("Publish houses"));
			markup = g_markup_printf_escaped (_("<u><b>Translators</b></u>"));
			gtk_label_set_markup (GTK_LABEL (GTK_BIN (translators_but)->child), markup);
			gtk_label_set_text (GTK_LABEL (GTK_BIN (languages_but)->child), _("Languages"));
			break;
		case 4:
			gtk_label_set_text (GTK_LABEL (GTK_BIN (authors_but)->child), _("Authors"));
			gtk_label_set_text (GTK_LABEL (GTK_BIN (generes_but)->child), _("Generes"));
			gtk_label_set_text (GTK_LABEL (GTK_BIN (pub_houses_but)->child), _("Publish houses"));
			gtk_label_set_text (GTK_LABEL (GTK_BIN (translators_but)->child), _("Transtalors"));
			markup = g_markup_printf_escaped (_("<u><b>Languages</b></u>"));
			gtk_label_set_markup (GTK_LABEL (GTK_BIN (languages_but)->child), markup);;
			break;
	}
	
	/*	Tekst w etykiecie 'main_lb' na adekwatny do edytowanej tabeli bazy 
		danych	*/
	
	switch (menage_db_mode)	{
		case 0:
			markup = g_markup_printf_escaped (_("<span size=\"large\"><b>Manage authors</b></span>"));
			break;
		case 1:
			markup = g_markup_printf_escaped (_("<span size=\"large\"><b>Manage genres</b></span>"));
			break;
		case 2:
			markup = g_markup_printf_escaped (_("<span size=\"large\"><b>Manage\npublishing houses</b></span>"));
			break;
		case 3:
			markup = g_markup_printf_escaped (_("<span size=\"large\"><b>Manage translators</b></span>"));
			break;
		case 4:
			markup = g_markup_printf_escaped (_("<span size=\"large\"><b>Manage languages</b></span>"));
			break;
	}
	label = glade_xml_get_widget (xml, "main_lb");
	gtk_label_set_markup (GTK_LABEL (label), markup);
	
	/*	Tekst w etykiecie 'entry_lb' na adekwatny do edytowanej tabeli bazy 
		danych	*/
	
	label = glade_xml_get_widget (xml, "entry_lb");
	switch (menage_db_mode)	{
		case 0:
			gtk_label_set_text (GTK_LABEL (label), _("New author"));
			break;
		case 1:
			gtk_label_set_text (GTK_LABEL (label), _("New genre"));
			break;
		case 2:
			gtk_label_set_text (GTK_LABEL (label), _("New publish house"));
			break;
		case 3:
			gtk_label_set_text (GTK_LABEL (label), _("New translator"));
			break;
		case 4:
			gtk_label_set_text (GTK_LABEL (label), _("New language"));
			break;
	}
	
	/*	Ustawiamy naglowki w liscie na adekwatne do edytowanej tabeli 
	 *	bazy danych	*/
	
	list = glade_xml_get_widget (xml , "items_list");
	column = gtk_tree_view_get_column (GTK_TREE_VIEW (list), 1);
	switch (menage_db_mode)	{
		case 0:
			gtk_tree_view_column_set_title (column, _("Authors"));
			break;
		case 1:
			gtk_tree_view_column_set_title (column, _("Generes"));
			break;
		case 2:
			gtk_tree_view_column_set_title (column, _("Publish houses"));
			break;
		case 3:
			gtk_tree_view_column_set_title (column, _("Translators"));
			break;
		case 4:
			gtk_tree_view_column_set_title (column, _("Languages"));
			break;
	}

	/*
	 *	Czyscimy i ladujemy liste
	 */
	clear_list_list (list);
	load_table (widget);
	/*
	 *	Teraz czyscimy pole tekstowe i "reserujemy" przyciski
	 */
	entry = glade_xml_get_widget (xml, "item_name_en");
	gtk_entry_set_text (GTK_ENTRY (entry), "");
	set_widget_sensinitive (widget, "item_remove_but", FALSE);
	set_widget_sensinitive (widget, "item_add_but", FALSE);
	
	g_free (markup);
}

/*
 *	Funkcja laduje liste z odpowiedniej tabeli bazy danych wskazanej przez
 *	'menage_db_mode'
 */

void	load_table	(GtkWidget	*widget)		{
	GladeXML			*xml;
	GtkTreeView			*treeview;
	GtkTreeModel		*store;
	GtkTreeIter 		iter;	
	gint				status;
	gint				rows;
	sqlite3_stmt		*db_row;
	
	status = 0;
	xml = glade_get_widget_tree (widget);
	
	treeview = GTK_TREE_VIEW (glade_xml_get_widget (xml, "items_list"));
	/*	Profilaktycznie czyscimy liste	*/
	clear_list_list (GTK_WIDGET (treeview));
	
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (treeview));
	
	switch (menage_db_mode)	{
		case 0:
			rows = count_returned_rows ("SELECT COUNT(id) FROM authors;");
			break;
		case 1:
			rows = count_returned_rows ("SELECT COUNT(id) FROM generes;");
			break;
		case 2:
			rows = count_returned_rows ("SELECT COUNT(id) FROM publish_houses;");
			break;
		case 3:
			rows = count_returned_rows ("SELECT COUNT(id) FROM translators;");
			break;
		case 4:
			rows = count_returned_rows ("SELECT COUNT(id) FROM languages;");
			break;
	}
	g_printf(">>> Loading data, number of returned rows: %d\n", rows);
	
	switch (menage_db_mode)	{
		case 0: 
			sqlite3_prepare (database, "SELECT id, author FROM authors;", -1, &db_row, 0);
			break;
		case 1:
			sqlite3_prepare (database, "SELECT id, genere FROM generes;", -1, &db_row, 0);	
			break;
		case 2:
			sqlite3_prepare (database, "SELECT id, publish_house FROM publish_houses;", -1, &db_row, 0);
			break;
		case 3:
			sqlite3_prepare (database, "SELECT id, translator FROM translators;", -1, &db_row, 0);	
			break;
		case 4:
			sqlite3_prepare (database, "SELECT id, language FROM languages;", -1, &db_row, 0);	
			break;
	}
		
	status = sqlite3_step (db_row);
	g_printf ("\t<<< Got first row, SQLite result: %d\n", status);
	if (rows > 0)	{
		while (status == 100)		{
			gtk_list_store_append (GTK_LIST_STORE (store), &iter);
			gtk_list_store_set (GTK_LIST_STORE (store), &iter,
								0, sqlite3_column_int (db_row, 0),
								1, sqlite3_column_text (db_row, 1),
								-1);
			status = sqlite3_step (db_row);
		}
		g_printf ("\t<<< Got last row, SQLite result: %d\n", status);
	}	
	
	sqlite3_finalize (db_row);
}

/*
 *	Funkcja dodaje do tabeli wskazanej przez argument 'mode' element o nazwie 
 *	wskazanej w 'name'. Funkcja sprawdza, czy element o nazwie 'name'
 *	nie znajduje sie juz w bazie danych.
 */

void	add_item	(gchar	*name)	
{
	sqlite3_stmt	*db_row;
	gchar			sql_query	[SHORT_STRING];
	gint			status;
	gint			returned_rows;

	/*
	 *	Przygotowujemy zapytania SQL by szprawdzic, czy dodanana nazwa nie 
	 *	znajduje sie juz w bazie danych
	 */
	switch (menage_db_mode)	{
		case 0:
			g_sprintf (sql_query, "SELECT id FROM authors WHERE author=\'%s\';",
								  name);
			break;
		case 1:
			g_sprintf (sql_query, "SELECT id FROM generes WHERE genere=\'%s\';",
								  name);
			break;
		case 2:
			g_sprintf (sql_query, "SELECT id FROM publish_houses WHERE publish_house=\'%s\';",
								  name);
			break;
		case 3:
			g_sprintf (sql_query, "SELECT id FROM translators WHERE translator=\'%s\';",
								  name);
			break;
		case 4:
			g_sprintf (sql_query, "SELECT id FROM languages WHERE language=\'%s\';",
								  name);
			break;
	}
	
	returned_rows = count_returned_rows (sql_query);
	g_printf (">>> Checking if item exist in database, result: %d\n", returned_rows);
	/*
	 *	Jezeli 'status' jest rowny zeru, oznacza to ze w bazie nie znajduje sie
	 *	pozycja o nazwie 'name'
	 */
	if (returned_rows == 0)	{
		switch (menage_db_mode)	{
			case 0:
				g_sprintf (sql_query, "INSERT INTO authors (id, author) VALUES (NULL, \'%s\');",
									  name);
				break;
			case 1:
				g_sprintf (sql_query, "INSERT INTO generes (id, genere) VALUES (NULL, \'%s\');",
									  name);
				break;
			case 2:
				g_sprintf (sql_query, "INSERT INTO publish_houses (id, publish_house) VALUES (NULL, \'%s\');",
									  name);
				break;
			case 3:
				g_sprintf (sql_query, "INSERT INTO translators (id, translator) VALUES (NULL, \'%s\');",
								  name);
				break;
			case 4:
				g_sprintf (sql_query, "INSERT INTO languages (id, language) VALUES (NULL, \'%s\');",
									  name);
				break;
		}
		sqlite3_prepare (database, sql_query, -1, &db_row, 0);	
		status = sqlite3_step (db_row);
		switch (menage_db_mode)	{
			case 0:
				g_printf ("<<< Adding new author, SQLite result: %d\n", status);
				break;
			case 1:
				g_printf ("<<< Adding new genere, SQLite result: %d\n", status);
				break;
			case 2:
				g_printf ("<<< Adding new publish house, SQLite result: %d\n", status);
				break;
		}
		sqlite3_finalize (db_row);
	}
	else if (returned_rows > 0)	{
		show_message_dlg (_("Duplicated data"), _("There allready is item with this name "
						"in database."), 1);
	}
	/*
	 *	Sytuacja malo prawdopodobna, ale jej wysapienie oznacza jakis 
	 *	(raczej powazny) blad
	 */
	else if (returned_rows < 0	)	{
		show_message_dlg (_("Error"), _("Unknown error while adding item, please try again."), 2);
	}
}

/*
 *	Funkcja usuwa pozycje o ID wskazanym przez argument 'item_id' z tabeli
 *	wskazanej przez globalna zmienna 'menage_db_mode'. Funkcja sprawdza, czy 
 *	usuwana pozycja nie jest wykorzystywana przez jakas ksiazke w bazie danych.
 *	Jezeli jest usuwanie zostaje wstrzymane i zostaje wyswietlony komunikat.
 *	
 *	Wartosci dla 'mode':
 *	- 0 - tylko usuwanie pozycji
 *	- 1 - usuwanie pozycji i aktualizacja ksiazek
 */

void	remove_item		(gint	item_id, gint	mode)	{
	sqlite3_stmt	*db_row;
	gint			status;
	gchar			sql_query		[SHORT_STRING];
	
	switch (menage_db_mode)	{
		case 0:
			g_sprintf (sql_query, "DELETE FROM authors WHERE id=%d;", item_id);
			break;
		case 1:
			g_sprintf (sql_query, "DELETE FROM generes WHERE id=%d;", item_id);
			break;
		case 2:
			g_sprintf (sql_query, "DELETE FROM publish_houses WHERE id=%d;", item_id);
			break;
		case 3:
			g_sprintf (sql_query, "DELETE FROM translators WHERE id=%d;", item_id);
			break;
		case 4:
			g_sprintf (sql_query, "DELETE FROM languages WHERE id=%d;", item_id);
			break;
	}
	sqlite3_prepare(database, sql_query, -1, &db_row, 0);
	status = sqlite3_step (db_row);
	g_printf (">>> Removing item, SQLite result: %d\n", status);
	
	sqlite3_finalize (db_row);
}

/*	
 *	Funkcja sprawdza czy dany autor, tlumacz, gatunek itd. o wskazanym przez
 *	argument 'item_id' numerze ID jest uzywany przez jakakolwiek ksiazke w 
 *	bazie dancyh. Rodzaj sprawdzanych danych okresla argument 'mode'
 */

gboolean	check_if_item_is_used		(gint	item_id, gint	mode)	{
	gint			items_number;
	gchar			sql_query		[SHORT_STRING];
	
	items_number = 0;
	
	switch (mode)	{
		case 0:
			g_printf (">>> Checking if author is used...\n");
			g_sprintf (sql_query, 
				"SELECT COUNT(id) FROM single_volume_books WHERE first_author = %d OR "
				"second_author = %d OR third_author = %d;",
				item_id, item_id, item_id);
			items_number += count_returned_rows (sql_query);
		
			g_sprintf (sql_query, 
				"SELECT COUNT(id) FROM multi_volume_books_shared_data WHERE first_author = %d OR "
				"second_author = %d OR third_author = %d;",
				item_id, item_id, item_id);
			items_number += count_returned_rows (sql_query);
			break;
		case 1:
			g_printf (">>> Checking if genre is used...\n");
			g_sprintf (sql_query, 
				"SELECT COUNT(id) FROM single_volume_books WHERE genere = %d;",
				item_id);
			items_number += count_returned_rows (sql_query);
		
			g_sprintf (sql_query, 
				"SELECT COUNT(id) FROM multi_volume_books_shared_data WHERE genere = %d;",
				item_id);
			items_number += count_returned_rows (sql_query);
			break;
		case 2:
			g_printf (">>> Checking if publish house is used...\n");
			g_sprintf (sql_query, 
				"SELECT COUNT(id) FROM single_volume_books WHERE publish_house = %d;",
				item_id);
			items_number += count_returned_rows (sql_query);
		
			g_sprintf (sql_query, 
				"SELECT COUNT(id) FROM multi_volume_books_shared_data WHERE publish_house = %d;",
				item_id);
			items_number += count_returned_rows (sql_query);
			break;
		case 3:
			g_printf (">>> Checking if translator is used...\n");
			g_sprintf (sql_query, 
				"SELECT COUNT(id) FROM single_volume_books WHERE first_translator = %d OR "
				"second_translator = %d OR third_translator = %d;",
				item_id, item_id, item_id);
			items_number += count_returned_rows (sql_query);
		
			g_sprintf (sql_query, 
				"SELECT COUNT(id) FROM multi_volume_books_shared_data WHERE first_translator = %d OR "
				"second_translator = %d OR third_translator = %d;",
				item_id, item_id, item_id);
			items_number += count_returned_rows (sql_query);
		
			g_sprintf (sql_query, 
				"SELECT COUNT(id) FROM multi_volume_books_private_data WHERE first_translator = %d OR "
				"second_translator = %d OR third_translator = %d;",
				item_id, item_id, item_id);
			items_number += count_returned_rows (sql_query);
			break;
		case 4:
			g_printf (">>> Checking if language is used...\n");
			g_sprintf (sql_query, 
				"SELECT COUNT(id) FROM single_volume_books WHERE language = %d OR "
				"orginal_language = %d;",
				item_id, item_id);
			items_number += count_returned_rows (sql_query);
		
			g_sprintf (sql_query, 
				"SELECT COUNT(id) FROM multi_volume_books_shared_data WHERE language = %d OR "
				"orginal_language = %d;",
				item_id, item_id);
			items_number += count_returned_rows (sql_query);
			break;
	}
	if (items_number > 0)	{
		show_message_dlg (_("Can't remove item"), 
			_("This item can't be removed, because it's used by some books in database."),
			2);
		return FALSE;
	}
	else	{
		return TRUE;
	}
}
